//package tools.descartes.dql.connector.simQPN.wastebasket;
//
//import java.util.HashMap;
//import java.util.Map;
//
//import org.eclipse.emf.ecore.util.EcoreUtil;
//
//import edu.kit.ipd.descartes.qpme.model.Color;
//import edu.kit.ipd.descartes.qpme.model.ColorReference;
//import edu.kit.ipd.descartes.qpme.model.OrdinaryPlace;
//import edu.kit.ipd.descartes.qpme.model.Place;
//import edu.kit.ipd.descartes.qpme.model.QueueingPetriNet;
//import edu.kit.ipd.descartes.qpme.model.QueueingPlace;
//import edu.kit.ipd.descartes.qpme.model.SubnetPlace;
//import tools.descartes.dql.connector.ModelStructureQueryConnector;
//import tools.descartes.dql.connector.simQPN.Activator;
//import tools.descartes.dql.connector.simQPN.ModelStructureQueryConnectorUtil;
//import tools.descartes.dql.models.mapping.domain.DoF;
//import tools.descartes.dql.models.mapping.domain.DomainFactory;
//import tools.descartes.dql.models.mapping.domain.Resource;
//import tools.descartes.dql.models.mapping.domain.Service;
//import tools.descartes.dql.models.mapping.mapping.EntityMapping;
//
//public class ModelStructureQueryConnectorImplEMF implements ModelStructureQueryConnector {
////	public String getBundleProperty(String key) {
////		return Activator.getContext().getProperty(key);
////	}
//
//	@Override
//	public boolean supportsDoFRequests() {
//		return true;
//	}
//
//	@Override
//	public boolean supportsEntityRequests() {
//		return true;
//	}
//
//	@Override
//	public boolean supportsProbeRequests() {
//		return true;
//	}
//
//	@Override
//	public EntityMapping requestDoF(EntityMapping request) {
//		final EntityMapping response = EcoreUtil.copy(request);
//		
//		//Load Model
//		QueueingPetriNet loadedQPN = EMFUtil.loadQPN(request.getModelLocation());
//		
//
//		for (Place p: loadedQPN.getPlaces().getDefinitions())
//			if(p.getColorReferences() != null)
//				for (ColorReference cr: p.getColorReferences().getDefinitions()) {
//					DoF dof = DomainFactory.eINSTANCE.createDoF();
//					dof.setIdentifier(ModelStructureQueryConnectorUtil.createDofIdentifier(p.getName(), cr.getColor().getName()));
//					response.getDoF().add(dof);
//				}
//		return response;
//	}
//
//	@Override
//	public EntityMapping requestEntities(EntityMapping request) {
//		final EntityMapping response = EcoreUtil.copy(request);
//		
//		//Load Model
//		QueueingPetriNet loadedQPN = EMFUtil.loadQPN(request.getModelLocation());
//		
//		//Add resources
//		for(Place p: loadedQPN.getPlaces().getDefinitions()) {
//			response.getResources().add(ModelStructureQueryConnectorUtil.createResource(p.getName()));
//		}
//		
//		//Add services
////		for(Color c: loadedQPN.getColors().getDefinitions()) {
////			response.getServices().add(ModelStructureQueryConnectorUtil.createService(c.getName()));
////		}
//		
//		return response;
//	}
//
//	@Override
//	public EntityMapping requestProbes(EntityMapping request) {
//		final EntityMapping response = EcoreUtil.copy(request);
//		
//		//Load Model
//		QueueingPetriNet loadedQPN = EMFUtil.loadQPN(request.getModelLocation());
//		
//		Map<String, String> typeMap = new HashMap<String, String>();
//		for (Place p: loadedQPN.getPlaces().getDefinitions())
//			typeMap.put(p.getName(), getNameofPlace(p));
//		
////		for (Service s: response.getServices()) {
////			s.getProbes().clear();
////			s.getProbes().addAll(ModelStructureQueryConnectorUtil.getAvailibleProbes(s));
////		}
//		
//		for (Resource r: response.getResources()) {
//			r.getProbes().clear();
////			r.getProbes().addAll(ModelStructureQueryConnectorUtil.getAvailibleProbes(r, typeMap.get(r.getIdentifier())));
//		}
//		return response;
//	}
//	
//	public static String getNameofPlace(Place p) {
//		if (p instanceof OrdinaryPlace)
//			return "ordinary-place";
//		if (p instanceof QueueingPlace)
//			return "queueing-place";
//		if (p instanceof SubnetPlace)
//			return "subnet-place";
//		return null;
//	}
//}
