//package tools.descartes.dql.connector.simQPN.wastebasket;
//
//import java.util.Collection;
//import java.util.LinkedList;
//import java.util.List;
//
//import org.dom4j.Element;
//
//import tools.descartes.dql.connector.simQPN.NetUtil;
//import tools.descartes.dql.models.mapping.domain.Probe;
//import de.tud.cs.qpe.model.NetHelper;
//import de.tud.cs.qpe.model.PlaceHelper;
//
//public class snippets {
//
//	private static Collection<? extends Probe> getAvailibleProbesForQueueOLD(
//			Element element, Element net) {
//		List<String> names = new LinkedList<String>();
//		
//		//Add metrics for depository
//		for (String depositoryMetricName: getNamesOfAvailibleProbesForOrdinaryPlace(
//				PlaceHelper.listColorReferences(element), net))
//			names.add("depository" + metricSeperator + depositoryMetricName);
//		
//		//Add metrics for underlying Queue
//		names.addAll(getMetricNamesForUnderlyingQueue());
//		
//		//Add metrics for queueing place
//		names.addAll(getMetricNamesForQueueingPlace(PlaceHelper.listColorReferences(element), net));
//
//		validateAgainstDuplicateNames(names);
//		List<Probe> probes = new LinkedList<Probe>();
//		for (String name: names) {
//			probes.add(createProbe(name));
//		}
//		return probes;
//	}
//
//
//	private static List<String> getMetricNamesForQueueingPlace(List<Element> listColorReferences,
//			Element net) {
//		List<String> names = new LinkedList<String>();
//		names.add("QueueUtilizationDueToThisPlace");
//		for (Element colorRef: listColorReferences) {
//			String colorName = NetUtil.getNameOfElement(NetHelper.getColorById(net, 
//					NetUtil.getColorRefId(colorRef)));
//			for (String placeMetricName: getNamesForPlaceMetrics()) {
//				names.add(qualifyByRemoval(colorName) + metricSeperator + placeMetricName);
//			}
//		}
//		return names;
//	}
//
//
//	private static List<String> getMetricNamesForUnderlyingQueue() {
//		//TODO do i add the name? What if 2 underlying queues?
//		List<String> names = new LinkedList<String>();
//		names.add("MeanTotalTokenPopulation");
//		names.add("MeanTokenResidenceTime");
//		names.add("QueueUtilization");
//		names.add("TotalArrivalThroughput");
//		names.add("TotalDepartureThroughput");
//		for (int i = 0; i < names.size(); i++) {
//			names.set(i, "UnderlyingQueue_" + names.get(i));
//		}
//		return names;
//	}
//
//	private static void validateAgainstDuplicateNames(List<String> metricNames) {
//		for (int i = 0; i < metricNames.size(); i++) {
//			for (int j = i + 1; j < metricNames.size(); j++)
//				if(metricNames.get(i).equals(metricNames.get(j)))
//					throw new IllegalArgumentException("Some color/placenames contain chars aside"
//							+ " from [A-Za-z0-9_] and the model can therefor not be evaluated");
//		}
//	}
//
//	private static String qualifyByReplacingWithUnderscores(String name) {
//		String ret = "";
//		for (int i = 0; i < name.length(); i++) {
//			String digit = name.substring(i, i + 1);
//			if (digit.matches("\\w")) {
//				ret += digit;
//			} else {
//				ret += "_";
//			}
//		}
//		return ret;
//	}
//
//	private static List<String> qualifyPlaceNames(Element net) {
//		List<String> placeNames = new LinkedList<String>();
//		for (Element e: NetHelper.listPlaces(net))
//			placeNames.add(qualifyByReplacingWithUnderscores(NetUtil.getNameOfElement(e)));
//		validateAgainstDuplicateNames(placeNames);
//		return placeNames;
//	}
//
//
//	private static List<Probe> getAvailibleProbesForOrdinaryPlaceOLD(
//			Element element, Element net) {
//		List<String> names = getNamesOfAvailibleProbesForOrdinaryPlace(
//				PlaceHelper.listColorReferences(element), net);
//		List<Probe> probes = new LinkedList<Probe>();
//		for (String name: names) {
//			probes.add(createProbe(name));
//		}
//		return probes;
//	}
//
//	private static List<String> getNamesForPlaceMetrics() {
//		List<String> names = new LinkedList<String>();
//		names.add("TokenColorOccupancy");
//		names.add("MaximumTokenPopulation");
//		names.add("MeanTokenPopulation");
//		names.add("MaximumTokenResidenceTime");
//		names.add("StandardDeviationTokenResidenceTime");
//		names.add("MeanTokenResidenceTime");
//		names.add("MinimumTokenResidenceTime");
//		names.add("ConfidenceIntervalMean");
//		names.add("MinimumTokenPopulation");
//		names.add("ConfidenceIntervalHalfLength");
//		names.add("ArrivalThroughput");
//		names.add("DepartureThroughput");
//		return names;
//	}
//	
//	private static List<String> getNamesOfAvailibleProbesForOrdinaryPlace(
//			List<Element> listColorReferences, Element net) {
//		List<String> names = new LinkedList<String>();
//		names.add("TokenOccupancy");
//		for (Element colorRef: listColorReferences) {
//			String colorName = NetUtil.getNameOfElement(NetHelper.getColorById(net,
//					NetUtil.getColorRefId(colorRef)));
//			for (String placeMetricName: getNamesForPlaceMetrics()) {
//				names.add(qualifyByRemoval(colorName) + metricSeperator + placeMetricName);
//			}
//		}
//		return names;
//	}
//
//}
